﻿namespace LFS_External
{
    using System;

    public class Enums
    {
        public enum BtnFunc : byte
        {
            BFN_CLEAR = 1,
            BFN_DEL_BTN = 0,
            BFN_REQUEST = 3,
            BFN_USER_CLEAR = 2
        }

        public enum CNL_Reason : byte
        {
            LEAVR_BANNED = 4,
            LEAVR_DISCO = 0,
            LEAVR_KICKED = 3,
            LEAVR_LOSTCONN = 2,
            LEAVR_NUM = 6,
            LEAVR_SECURITY = 5,
            LEAVR_TIMEOUT = 1
        }

        public enum Flags : byte
        {
            FLAG_BLUE = 1,
            FLAG_YELLOW = 2
        }

        public enum MSL_Sound : byte
        {
            SND_ERROR = 4,
            SND_INVALIDKEY = 3,
            SND_MESSAGE = 1,
            SND_NUM = 5,
            SND_SILENT = 0,
            SND_SYSMESSAGE = 2
        }

        public enum MSO_UserType : byte
        {
            MSO_NUM = 4,
            MSO_O = 3,
            MSO_PREFIX = 2,
            MSO_SYSTEM = 0,
            MSO_USER = 1
        }

        public enum NPL_Tyres : byte
        {
            TYRE_HYBRID = 6,
            TYRE_KNOBBLY = 7,
            TYRE_NOTCHANGED = 0xff,
            TYRE_NUM = 8,
            TYRE_R1 = 0,
            TYRE_R2 = 1,
            TYRE_R3 = 2,
            TYRE_R4 = 3,
            TYRE_ROAD_NORMAL = 5,
            TYRE_ROAD_SUPER = 4
        }

        public enum Packets : byte
        {
            IRP_ERR = 0xff,
            IRP_HLR = 0xfc,
            IRP_HOS = 0xfd,
            IRP_SEL = 0xfe,
            ISP_AXI = 0x2b,
            ISP_AXO = 0x2c,
            ISP_BFN = 0x2a,
            ISP_BTC = 0x2e,
            ISP_BTN = 0x2d,
            ISP_BTT = 0x2f,
            ISP_CCH = 0x1d,
            ISP_CNL = 0x13,
            ISP_CPP = 9,
            ISP_CPR = 20,
            ISP_CRS = 0x29,
            ISP_FIN = 0x22,
            ISP_FLG = 0x20,
            ISP_III = 12,
            ISP_ISI = 1,
            ISP_ISM = 10,
            ISP_LAP = 0x18,
            ISP_MCI = 0x26,
            ISP_MOD = 15,
            ISP_MSL = 40,
            ISP_MSO = 11,
            ISP_MST = 13,
            ISP_MSX = 0x27,
            ISP_MTC = 14,
            ISP_NCN = 0x12,
            ISP_NLP = 0x25,
            ISP_NONE = 0,
            ISP_NPL = 0x15,
            ISP_PEN = 30,
            ISP_PFL = 0x21,
            ISP_PIT = 0x1a,
            ISP_PLA = 0x1c,
            ISP_PLL = 0x17,
            ISP_PLP = 0x16,
            ISP_PSF = 0x1b,
            ISP_REO = 0x24,
            ISP_RES = 0x23,
            ISP_RST = 0x11,
            ISP_SCC = 8,
            ISP_SCH = 6,
            ISP_SFP = 7,
            ISP_SMALL = 4,
            ISP_SPX = 0x19,
            ISP_STA = 5,
            ISP_TINY = 3,
            ISP_TOC = 0x1f,
            ISP_VER = 2,
            ISP_VTN = 0x10,
            ISP_CON = 50,
        }

        public enum Penalty : byte
        {
            PENALTY_30 = 5,
            PENALTY_45 = 6,
            PENALTY_DT = 1,
            PENALTY_DT_VALID = 2,
            PENALTY_NONE = 0,
            PENALTY_NUM = 7,
            PENALTY_SG = 3,
            PENALTY_SG_VALID = 4
        }

        public enum PenaltyReason : byte
        {
            PENR_ADMIN = 1,
            PENR_FALSE_START = 3,
            PENR_NUM = 7,
            PENR_SPEEDING = 4,
            PENR_STOP_LATE = 6,
            PENR_STOP_SHORT = 5,
            PENR_UNKNOWN = 0,
            PENR_WRONG_WAY = 2
        }

        public enum PitLaneReason : byte
        {
            PITLANE_DT = 3,
            PITLANE_ENTER = 1,
            PITLANE_EXIT = 0,
            PITLANE_NO_PURPOSE = 2,
            PITLANE_NUM = 5,
            PITLANE_SG = 4
        }

        internal enum Protocol
        {
            UDP,
            TCP
        }

        public enum Small : byte
        {
            SMALL_NLI = 7,
            SMALL_NONE = 0,
            SMALL_RTP = 6,
            SMALL_SSG = 2,
            SMALL_SSP = 1,
            SMALL_STP = 5,
            SMALL_TMS = 4,
            SMALL_VTA = 3
        }

        public enum Tiny : byte
        {
            TINY_AXC = 0x15,
            TINY_AXI = 20,
            TINY_CLOSE = 2,
            TINY_CLR = 12,
            TINY_GTH = 8,
            TINY_ISM = 10,
            TINY_MCI = 0x11,
            TINY_MPE = 9,
            TINY_NCN = 13,
            TINY_NLP = 0x10,
            TINY_NONE = 0,
            TINY_NPL = 14,
            TINY_PING = 3,
            TINY_REN = 11,
            TINY_REO = 0x12,
            TINY_REPLY = 4,
            TINY_RES = 15,
            TINY_RST = 0x13,
            TINY_SCP = 6,
            TINY_SST = 7,
            TINY_VER = 1,
            TINY_VTC = 5
        }

        public enum View : byte
        {
            VIEW_ANOTHER = 0xff,
            VIEW_CAM = 2,
            VIEW_CUSTOM = 4,
            VIEW_DRIVER = 3,
            VIEW_FOLLOW = 0,
            VIEW_HELI = 1
        }

        public enum VTN_Actions : byte
        {
            VOTE_END = 1,
            VOTE_NONE = 0,
            VOTE_NUM = 4,
            VOTE_QUALIFY = 3,
            VOTE_RESTART = 2
        }
    }
}

